#!/usr/bin/python

from OPCServer_client import *
from opc_xmlda_lib import *
import sys, time

#TRACE=sys.stdout
TRACE=None
INDENT_MAGIC=4


def item_callback (item, indent):
    print "%sval=%s, qlt=%s" % (
                               indent * "|   ", 
                               str (item.Value), 
                               str (item.Quality.get_attribute_QualityField ()))


def element_callback (element, indent):
    s = indent * "|   "

    print s
    print s[:-INDENT_MAGIC] + ("-" * INDENT_MAGIC) + \
          str (element.get_attribute_ItemName ())


def usage ():
    print "Usage: opc_browse.py URL"
    print


if len (sys.argv) > 1:
    if sys.argv[1] == '--help':
        usage ()

    else:
        url = sys.argv[1]
        loc = OPCServerLocator ()
        port = loc.getOPCServer (url, tracefile=TRACE)

        browse (port, "", 0, element_callback, item_callback)

else:
    usage ()
